////////////////////////////////////////////////////////////////////////////
//  Setup : A Windows 3.1 setup program by Paul Rogers (PWR), Nailsea, G.B.
//
//  Released into the public domain 15.10.95
//
//  Any comments to me via mail on Compuserve Paul Rogers, 100564,3311
//
//  If you improve it at all (particularly making the .exe file smaller)
//  you can do us all a favour and upload it
//  to compuserve's borland forum.. send me a message to me as well, I'll
//  probably be interested.
//
//  I would be very interested if you do a windows 95 version, I havent got
//  it yet but it will save me some time when I do, all that registry business
//  sounds better....
//
//  If you really like it and you've got a few (euro) bob lying around guv,
//  I certainly wont refuse it... but dont worry about it...
//
//  Cheers....
//
//  General : This is the second version, having changed it to now do a
//  shaded blue background, and also to use the ProgMan DDE classes I got
//  off here from Michael weber.  All the file names and messages reflect
//  the fact that this version installs a program I'm writing called
//  Disk History which uses the BDE API
///////////////////////////////////////////////////////////////////////
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\dc.h>
#include <owl\static.h>
#include <owl\gdiobjec.h>
#include <owl\gauge.h>
#include <owl\edit.h>
#include <dir.h>
#include <ver.h>
#include <stdio.h>
#include <windows.h>
#include "Dde_Prog.h"
#include "setup.rc"
#define numColours 64

class IApp;

//////////////////////////////////
// The custom control class.
//////////////////////////////////
class TBitmapCtrl : public TStatic
{
protected:
	TBitmap *bitmap;

public:
	TBitmapCtrl(TWindow *parent, int resId) :
		TStatic(parent, resId, 0) {};

protected:
	void Paint(TDC &paintDC, BOOL, TRect&);
	void EvPaint();
	void SetupWindow();

	DECLARE_RESPONSE_TABLE(TBitmapCtrl);
};

DEFINE_RESPONSE_TABLE1(TBitmapCtrl, TStatic)
	EV_WM_PAINT,
END_RESPONSE_TABLE;

//////////////////////////////////
// The Dialog class.
//////////////////////////////////
class IDlg : public TDialog
{
public:
  IDlg(TWindow *parent, TResId resId) : TDialog(parent,resId)
  {  bmp = new TBitmapCtrl(this, IDC_BITMAP);
	  SolidGauge = new TGauge(this, "%d%%", ID_SOLIDGAUGE, 80, 15, 240, 34, TRUE, 2);
	  Path = new TEdit(this,IDC_EDIT1);
 }
  void SetupWindow();
protected:
  TBitmapCtrl* bmp;
  TGauge*   SolidGauge;
  TBrush*   BkBrush;
  TEdit*    Path;
  void		CmOk();
  void		CmCancel();
  void		CmHelp();

  BOOL    EvEraseBkgnd(HDC);
  HBRUSH  EvCtlColor(HDC, HWND hWndChild, UINT ctlType);
  DECLARE_RESPONSE_TABLE(IDlg);
};

DEFINE_RESPONSE_TABLE1(IDlg, TDialog)
	 EV_WM_CTLCOLOR,
	 EV_COMMAND(IDOK,CmOk),
	 EV_COMMAND(IDCANCEL,CmCancel),
	 EV_COMMAND(998,CmHelp),
END_RESPONSE_TABLE;

//////////////////////////////////
// The main window class.
//////////////////////////////////
class IFWndw : public TFrameWindow
{
public:
  IFWndw(TWindow *parent, const char far *title, TWindow *cw, bool sc);
protected:
  void SetupWindow();

};

/////////////////////////////////////////////
// The client window class to paint backdrop
/////////////////////////////////////////////
class IWndw : public TWindow
{ IDlg *Id;
  LOGPALETTE* logPal;    // Logical Palette
  HPALETTE hLogPal;     // Handle to Logocal Palette
  friend class IApp;
public:
  IWndw(TWindow *parent, const char *title) : TWindow(parent,title) { }
  void SetupWindow();
  void Paint(TDC& dc, BOOL, TRect&);
  void EvDestroy();
  void EvSize(uint sizeType,TSize& size);
  void EvTimer(UINT);
  DECLARE_RESPONSE_TABLE(IWndw);
};
DEFINE_RESPONSE_TABLE1(IWndw, TWindow)
  EV_WM_DESTROY,
  EV_WM_SIZE,
  EV_WM_TIMER,
END_RESPONSE_TABLE;

/////////////////////////////////////////////
// The App Class
/////////////////////////////////////////////
class IApp : public TApplication {
public:
  IWndw *bw;
  IFWndw *mw;
  IApp() : TApplication() { }
  void InitMainWindow();
};

///////////////////////////////////////////////////////////
// TBitmapCtrl::SetupWindow()
///////////////////////////////////////////////////////////
void TBitmapCtrl::SetupWindow()
{ // Let OWL do the regular setup.
  TStatic::SetupWindow();
  // Load the bitmap.
  TApplication *app = GetApplication();
  HINSTANCE hInstance = app->GetInstance();
  bitmap = new TBitmap(hInstance, BM_DISKHIST);
}

///////////////////////////////////////////////////////////
// TBitmapCtrl::EvPaint()  (Do I really need to do this???)
///////////////////////////////////////////////////////////
void TBitmapCtrl::EvPaint()
{ // Force a call to the control's Paint() function.
  TWindow::EvPaint();
}

///////////////////////////////////////////////////////////
// TBitmapCtrl::Paint()
///////////////////////////////////////////////////////////
void TBitmapCtrl::Paint(TDC &paintDC, BOOL, TRect&)
{ // Display the bitmap.
  TMemoryDC mdc(paintDC);
  mdc.SelectObject(*bitmap);
  paintDC.BitBlt(0, 0, 32, 32, mdc, 0, 0, SRCCOPY);
}

////////////////////////////////////////////////////
// Cancel the app
///////////////////////////////////////////////////
void IDlg::CmCancel()
{ TDialog::CmCancel();
  Parent->PostMessage(WM_CLOSE,0,0);
}

////////////////////////////////////////////////////
// Install the app (phew a bit monolithic eh what..)
///////////////////////////////////////////////////
void IDlg::CmOk()
{ ////////////////////////////////////////////////
  // Do The copying
  ////////////////////////////////////////////////
  int mbr,insterr;
  char *iname[16],s[300],mess[300];
  int ipc[16], gv=0;
  UINT flags=0,findresult=0;					/* source-file flags	*/
  char destdir[MAXDIR],lpszWinDir[MAXDIR];/* address of Windows directory	*/
  char lpszCurDir[MAXDIR];					/* address of buffer for current directory	*/
  UINT  lpuCurDirLen=MAXDIR;					/* address of buffer size for directory	*/
  char lpszDestDir[MAXDIR];					/* address of buffer for dest. directory	*/
  UINT  lpuDestDirLen=MAXDIR;				/* address of size for dest. directory	*/
  WORD wReturn;
  DWORD instresult;
  char  lpszTmpFile[MAXDIR];
  char  sourcefile[MAXFILE+MAXEXT+1];
  UINT   lpwTmpFileLen=MAXDIR; /* address of size for temp dir name directory	*/
  FILE *test;

  // INSTALL DISKHIST files in selected Directory

  iname[0]  = "DISKHIST.PRF";   ipc[0]  = 1;
  iname[1]  = "DHHIST.MB";      ipc[1]  = 1;
  iname[2]  = "DHHIST.PX";      ipc[2]  = 1;
  iname[3]  = "DHEVENT.PX";     ipc[3]  = 1;
  iname[4]  = "DHEVENT.DB";     ipc[4]  = 1;
  iname[5]  = "DHHIST.DB";      ipc[5]  = 1;
  iname[6]  = "IDAPI.CFG";      ipc[6]  = 1;
  iname[7]  = "IDR10009.DLL";   ipc[7]  = 2;
  iname[8]  = "BIDS45.DLL";     ipc[8]  = 4;
  iname[9]  = "DISKHIST.EXE";   ipc[9]  = 5;
  iname[10] = "BWCC.DLL";       ipc[10] = 7;
  iname[11] = "BC450RTL.DLL";   ipc[11] = 9;
  iname[12] = "ILD01.DLL";      ipc[12] = 11;
  iname[13] = "IDPDX01.DLL";    ipc[13] = 15;
  iname[14] = "IDAPI01.DLL";    ipc[14] = 18;
  iname[15] = "OWL250.DLL";     ipc[15] = 21;

  // get current drive and directory
  char curdir[MAXPATH];
  strcpy(curdir, "X:\\");		  /* fill string with form of response: X:\ */
  curdir[0] = 'A' + getdisk();  /* replace X with current drive letter */
  getcurdir(0, curdir+3);		  /* fill rest of string with current directory */

  // Get the Windows Directory
  wReturn = GetWindowsDirectory((LPSTR)lpszWinDir, sizeof(lpszWinDir));
  if (wReturn == 0){
	 MessageBox( "function failed","GetWindowsDirectory", MB_ICONSTOP);
	 return;}
  else if (wReturn > sizeof(lpszWinDir)){
	 MessageBox( "buffer is too small","GetWindowsDirectory", MB_ICONSTOP);
	 return;}

  //  Get User Selected Directory

  char drive[MAXDRIVE];
  char dir[MAXDIR];
  char file[MAXFILE];
  char ext[MAXEXT];
  Path->GetText(s,50);  // get directory entered
  flags=fnsplit(s,drive,dir,file,ext);
  if(flags & DRIVE)
  { wsprintf(s,"drive: %s\n",drive);
	 setdisk(drive[0]-'A');
  }

  if(flags & DIRECTORY)
  { wsprintf(s,"%s\tdirectory: %s\n",s,dir);
	 strcpy(sourcefile,drive);
	 strcat(sourcefile,dir);
	 if (strlen(dir) > 1) sourcefile[strlen(sourcefile)-1] = 0;
	 if (chdir(sourcefile))
	 { wsprintf(mess,"Path %s Doesnt Exist, change or create it",sourcefile);
		MessageBox(mess,"Can't Proceed",MB_ICONEXCLAMATION);
		return;
	 }
	 strcpy(sourcefile,""); 		// clean up temp use of sourcefile.
  }

  if(flags & FILENAME)
  { wsprintf(s,"%s\tfile: %s\n",s,file);
	 strcpy(sourcefile,file);
	 if(flags & EXTENSION)
	 {	wsprintf(s,"%s\textension: %s\n",s,ext);
		strcat(sourcefile,ext);
	 }
	 if (chdir(sourcefile))
		if (mkdir(sourcefile))
		{ 	wsprintf(mess,"Can't create Directory %s%s%s",drive,dir,sourcefile);
			MessageBox(mess,"Can't Proceed",MB_ICONEXCLAMATION);
			setdisk(curdir[0]-'A');
			chdir(curdir);
			return;
		}
  }

  setdisk(curdir[0]-'A');
  chdir(curdir);

  // Set dest Dir to user selected dir
  wsprintf(destdir,"%s%s%s",drive,dir,sourcefile);
  // MessageBox(destdir,"destdir");

  ofstream logfile;  // set up LOG file for errors
  logfile.open("c:dhinst.log");

  if (!logfile) {
	 MessageBox("Couldnt open Log File","Can't Proceed",MB_ICONSTOP);
	 return;
  }

  for (int i=0;i<16;i++){

  this->Path->SetText(iname[i]);  // display file being installed
  //////////////////////////////////////////////////////////////////
  // if run from a: then prompt for disk 2 until inserted
  //////////////////////////////////////////////////////////////////
  if (i==16)
	 if (getdisk()==0)
	 { insterr = 1;
		while (insterr)
		{	if (MessageBox("Insert Disk 2 of 2","Change Disks",MB_ICONEXCLAMATION | MB_OKCANCEL)==IDCANCEL)
			{ this->Path->SetText("C:\\FODA");
			  // this->txt->SetText("Install to");
			  return;
			}
			test = fopen("sqcutil._ll","r");
			if (test)
			{ fclose(test);
			  insterr=0;
			}
		}
	 }

  /////////////////////////////////////////////////////
  // put remaining files in windows directory (probably c:\idapi actually)
  /////////////////////////////////////////////////////
  if (i==17) strcpy(destdir,lpszWinDir);

  flags=0;
  lpuCurDirLen=MAXDIR;					/* address of buffer size for directory*/
  lpuDestDirLen=MAXDIR;				/* address of size for dest. directory	*/

  findresult =  VerFindFile(flags, iname[i], lpszWinDir, destdir,
					  lpszCurDir, &lpuCurDirLen, lpszDestDir, &lpuDestDirLen);

  wsprintf(s,"FindFile result=%d, %s=curdir:len=%d, %s=destdir:len=%d",findresult,lpszCurDir,lpuCurDirLen,lpszDestDir,lpuDestDirLen);

  if (findresult & VFF_CURNEDEST)	wsprintf(s,"%s VFF_CURNEDEST",s);

  if (lpuCurDirLen > 1)   // if File exists already in the path or selected dir
	 if (i<17)				// If its a FoDa file ask if install again
	 {	wsprintf(mess,"File <%s> exists in <%s>\r\n\nInstall again in <%s>",iname[i],lpszCurDir,lpszDestDir);
		mbr = MessageBox(mess,"File already exists",MB_YESNOCANCEL | MB_DEFBUTTON2 | MB_ICONQUESTION);
		switch (mbr)
		{ case IDYES 		: 	flags = VIFF_DONTDELETEOLD;
									break;
		  case IDNO  		:	continue;
		  case IDCANCEL 	:  this->Path->SetText("C:\\FODA");
									// this->txt->SetText("Install to");
									return;
		 }
	 }
	 else						// Its an ODBC file skip installation as its there already
	 {	wsprintf(mess,"ODBC File <%s\\%s> exists in <%s>\r\n\nFile not Installed",lpszDestDir,iname[i],lpszCurDir);
		MessageBox(mess,"ODBC File install Skipped",MB_ICONINFORMATION);
		continue;
	 }

	 if (findresult & VFF_FILEINUSE)
	 { wsprintf(s,"%s VFF_FILEINUSE",s);
		wsprintf(mess,"File <%s\\%s> in use by Windows Cannot Install\r\n\nProbably Dont need it installed anyway...",lpszCurDir,iname[i]);
		MessageBox(mess,"File in use",MB_OK | MB_ICONEXCLAMATION);
		continue;
	 }

	 if (findresult & VFF_BUFFTOOSMALL)
	 { wsprintf(s,"%s VFF_BUFFTOOSMALL",s);
		wsprintf(mess,"File <%s> VerFindFile Buffer too Small\r\nCan't Install File",lpszCurDir,iname[i]);
		MessageBox(mess,"It'll never happen.... but it did.....?",MB_OK | MB_ICONQUESTION);
		continue;
	 }

	 logfile << iname[i] << "  " <<  s << "\n";
	 lpwTmpFileLen=MAXDIR;	 /* address of size for temp dir name directory	*/

	 ///////////////////////////////////////////////////////////////////
	 // Set up the name of the compressed files (use compress to compress)
	 // typical hassle with *._* as .mb & .db are the same so made it
	 // default which puts the _ as last character so need to
	 // split filename, get length of extension, and put _ in last bit
	 //////////////////////////////////////////////////////////////////
	 strcpy(sourcefile,iname[i]);
	 int j = strlen(sourcefile);
	 if ( strlen(strrchr(sourcefile,'.')) < 4) // its a 2 char extension
		sourcefile[j] = '_';
	 else           // its a 3 char extension
		 sourcefile[j-1] = '_';

	 sourcefile[j+1] = 0;  // put another terminator in (or the terminator)

	 instresult = VerInstallFile(flags, sourcefile, iname[i], curdir,
						lpszDestDir, lpszCurDir, lpszTmpFile, &lpwTmpFileLen);

	 gv += ipc[i];
	 SolidGauge->SetValue(gv);
	 GetApplication()->PumpWaitingMessages();
	 wsprintf(s,"InstallFile <%s\\%s> result=%ld, %s=tmpfile:len=%d,",lpszDestDir,iname[i],instresult,lpszTmpFile,lpwTmpFileLen);

	 insterr = 0;
	 if (instresult & VIF_TEMPFILE)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_TEMPFILE",s);
	 }
	 if (instresult & VIF_MISMATCH)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_MISMATCH",s);
	 }
	 if (instresult & VIF_SRCOLD)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_SRCOLD",s);
	 }
	 if (instresult & VIF_DIFFLANG)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_DIFFLANG",s);
	 }
	 if (instresult & VIF_DIFFCODEPG)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_DIFFCODEPG",s);
	 }
	 if (instresult & VIF_DIFFTYPE)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_DIFFTYPE",s);
	 }
	 if (instresult & VIF_WRITEPROT)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_WRITEPROT",s);
	 }
	 if (instresult & VIF_FILEINUSE)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_FILEINUSE",s);
	 }
	 if (instresult & VIF_OUTOFSPACE)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_OUTOFSPACE",s);
	 }
	 if (instresult & VIF_ACCESSVIOLATION)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_ACCESSVIOLATION",s);
	 }
	 if (instresult & VIF_SHARINGVIOLATION)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_SHARINGVIOLATION",s);
	 }
	 if (instresult & VIF_CANNOTCREATE)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_CANNOTCREATE",s);
	 }
	 if (instresult & VIF_CANNOTDELETE)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_CANNOTDELETE",s);
	 }
	 if (instresult & VIF_CANNOTRENAME)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_CANNOTRENAME",s);
	 }
	 if (instresult & VIF_OUTOFMEMORY)
	 { insterr = 1;
		 wsprintf(s,"%s VIF_OUTOFMEMORY",s);
	 }
	 if (instresult & VIF_CANNOTREADSRC)
	 { wsprintf(mess,"File <%s\\%s> could not be read\r\n\nRun Install from same Directory as compressed files",curdir,sourcefile);
		MessageBox(mess,"File Install skipped",MB_ICONEXCLAMATION);
		wsprintf(s,"%s VIF_CANNOTREADSRC",s);
		logfile << iname[i] << "  " <<  s << "\n";
		continue;
	 }

	 if (instresult & VIF_CANNOTREADDST)
	 {  insterr = 1;
			wsprintf(s,"%s VIF_CANNOTREADDST",s);
	 }
	 if (instresult & VIF_BUFFTOOSMALL)
	 {  insterr = 1;
			wsprintf(s,"%s VIF_BUFFTOOSMALL",s);
	 }
	 if (insterr) MessageBox(s, iname[i], MB_ICONEXCLAMATION);
		logfile << iname[i] << "  " <<  s << "\n";

	}
	///////////////////////////////////////////////////////////////////////
	// Set Up Progman Items (using classes by Michael Weber  - respect...)
	///////////////////////////////////////////////////////////////////////
	DdeProgMan ProgMan;
	char itempath[MAXPATH];
	ProgMan.CreateGroup("Disk History");
	wsprintf(itempath,"%s\\DiskHist",lpszDestDir);
	ProgMan.AddItem(itempath,"Disk History");
	SolidGauge->SetValue(100);
	logfile.close();
	MessageBox("Installed Successfully","Disk History",MB_ICONEXCLAMATION);

  //////////////////////////////////////////////////
  // Finished Succesfull Exit Program
  /////////////////////////////////////////////////

  TDialog::CmOk();
  Parent->PostMessage(WM_CLOSE,0,0);
}

////////////////////////////////////////////////////
// Show some help
///////////////////////////////////////////////////
void IDlg::CmHelp()
{ MessageBox("Enter the Path to Install to, and Press OK to Install\r\n\n\t\tOr\r\n\n"
				  "Press Cancel to Abort without Installing","Help",MB_ICONEXCLAMATION);
}

////////////////////////////////////////////////////
// Centre the Dialog Box
///////////////////////////////////////////////////
void IDlg::SetupWindow()
{ TRect parentRect, dlgRect;
  // Construct the dialog box's custom bitmap control.
  BkBrush = new TBrush(::GetSysColor(COLOR_BTNFACE));
  SolidGauge->SetRange(0, 100);
  // Allow OWL to perform regular setup.
  TDialog::SetupWindow();
  // Get the parent window's size.
  Parent->GetWindowRect(parentRect);
  // Get the dialog box's size.
  GetWindowRect(dlgRect);
  // Calculate the dialog box's new screen position.
  int xPos = parentRect.Width() / 2 -
		dlgRect.Width() / 2 + parentRect.left;
  int yPos = parentRect.Height() / 2 -
		dlgRect.Height() / 2 + parentRect.top;
  // Move the dialog box to its centered position.
  MoveWindow(xPos, yPos,dlgRect.Width(), dlgRect.Height());
  SolidGauge->SetRange(0, 100);
  SolidGauge->SetValue(0);
}

////////////////////////////////////////////////////////////////
// Provide a background color & brush for child controls to use
////////////////////////////////////////////////////////////////
HBRUSH IDlg::EvCtlColor(HDC hDC, HWND hWndChild, UINT ctlType)
{ ::SetBkColor(hDC, ::GetSysColor(COLOR_BTNFACE));
  return *BkBrush;
}

///////////////////////////////////////////////////////////
// IFWndw::SetupWindow() (or this...)
///////////////////////////////////////////////////////////
void IFWndw::SetupWindow()
{ // Call the base class's SetupWindow().
  TFrameWindow::SetupWindow();
}

///////////////////////////////////////////////////////////
// IFWndw::IFWndw() size the frame window nice and big....
///////////////////////////////////////////////////////////
IFWndw::IFWndw(TWindow *parent, const char far *title, TWindow *cw, bool sc):
		 TFrameWindow(parent, title, cw, sc)
{	Attr.W = GetSystemMetrics(SM_CXSCREEN) / 1.05;
	Attr.H = GetSystemMetrics(SM_CYSCREEN) / 1.05;
	Attr.X = (GetSystemMetrics(SM_CXSCREEN)-Attr.W)/2;
	Attr.Y = (GetSystemMetrics(SM_CYSCREEN)-Attr.H)/2;
}

////////////////////////////////////////////////////
// Run the install dialog automatically (give it a chance to set up first..)
///////////////////////////////////////////////////
void IWndw::EvTimer(UINT)
{ KillTimer(1);
  Id = new IDlg(this,DG_INSTALL);
  //Id->Create();
  Id->Execute();
}

////////////////////////////////////////////////////
// RePaint Backdrop when ReSized
///////////////////////////////////////////////////
void IWndw::EvSize(uint sizeType,TSize& size)
{ TWindow::EvSize(sizeType,size);
  Invalidate();
}

////////////////////////////////////////////////////
// Free up Memory used by palette
///////////////////////////////////////////////////
void IWndw::EvDestroy()
{ delete(logPal);
  delete Id;
  DeleteObject(hLogPal);
  TWindow::EvDestroy();
}

////////////////////////////////////////////////////
// create logical pallete with 64 (not too black more blue) shades of blue
///////////////////////////////////////////////////
void IWndw::SetupWindow()
{ TWindow::SetupWindow();
  logPal = (LOGPALETTE *)
	 (new char[sizeof(LOGPALETTE)+sizeof(PALETTEENTRY)*(numColours-1)]);
  logPal->palVersion = 0x300;
  logPal->palNumEntries = numColours;
  for (int i=0; i< numColours; i++)
  { logPal->palPalEntry[i].peRed = 0;
	 logPal->palPalEntry[i].peGreen = 0;
	 logPal->palPalEntry[i].peBlue =	BYTE(i*2.5+82);
	 logPal->palPalEntry[i].peFlags = 0;
  }
  hLogPal = ::CreatePalette(logPal);
  SetTimer(1,100);
}

////////////////////////////////////////////////////
// Paint blue graduated backdrop in window
///////////////////////////////////////////////////
void IWndw::Paint(TDC& dc,BOOL,TRect&)
{ RECT rect,rect2;
  HBRUSH hBrush;
  int i,stepSize;
  SelectPalette(dc,hLogPal,0);
  RealizePalette(dc);
  ::GetClientRect(HWindow, &rect);
  rect2.left =0; rect2.right = rect.right;
  stepSize = (rect.bottom - rect.top) / numColours + 1;
  for (i=0; i<numColours; i++)
  { hBrush = ::CreateSolidBrush(PALETTERGB(0,0,i*2.5+82));
	 rect2.top = rect.top + i * stepSize;
	 rect2.bottom = rect.top + (i + 1) * stepSize;
	 FillRect(dc,&rect2,hBrush);
	 DeleteObject(hBrush);
  }
}

////////////////////////////////////////////////////
// Set up main window
///////////////////////////////////////////////////
void IApp::InitMainWindow()
{ bw = new IWndw(0,"");
  mw = new IFWndw(0, "Set up Disk History for Windows",bw,FALSE);
  SetMainWindow(mw);
  mw->SetIcon(this,DISKHIST1);
}

////////////////////////////////////////////////////
// OwlMain (Thar she blows....)
///////////////////////////////////////////////////
int OwlMain(int, char*[])
{ return IApp().Run();
}


